import { jsx as l } from "react/jsx-runtime";
import { useMergeRefs as m, FloatingPortal as g, FloatingOverlay as p, FloatingFocusManager as M } from "@floating-ui/react";
import * as a from "react";
import { useId as b } from "react";
import C from "clsx";
import { ModalContext as v } from "./ModalContext.js";
import { useModalContext as d, useModal as x } from "./ModalHooks.js";
function f(c) {
  return b();
}
function w({
  children: c,
  ...t
}) {
  const n = x(t);
  return /* @__PURE__ */ l(v.Provider, { value: n, children: c });
}
const D = a.forwardRef(function(t, n) {
  const { context: r, ...o } = d(), e = m([o.refs.setFloating, n]);
  if (!r.open)
    return null;
  const { overlayBackground: s, ...i } = t, u = C("grid place-items-center", {
    [`${s}`]: s,
    "bg-black sm:bg-black/[.8]": !s
  });
  return /* @__PURE__ */ l(g, { children: /* @__PURE__ */ l(p, { className: u, lockScroll: !0, children: /* @__PURE__ */ l(M, { context: r, children: /* @__PURE__ */ l(
    "div",
    {
      ref: e,
      "aria-labelledby": o.labelId,
      "aria-describedby": o.descriptionId,
      ...o.getFloatingProps(i),
      children: i.children
    }
  ) }) }) });
}), E = a.forwardRef(function({ children: t, ...n }, r) {
  const { setLabelId: o } = d(), e = f();
  return a.useLayoutEffect(() => (o(e), () => o(void 0)), [e, o]), /* @__PURE__ */ l("h1", { ...n, ref: r, id: e, children: t });
}), L = a.forwardRef(function({ children: t, ...n }, r) {
  const { setDescriptionId: o } = d(), e = f();
  return a.useLayoutEffect(() => (o(e), () => o(void 0)), [e, o]), /* @__PURE__ */ l("div", { ...n, ref: r, id: e, children: t });
}), P = a.forwardRef(function(t, n) {
  const { setOpen: r } = d(), { trigger: o, className: e, ...s } = t, i = a.useCallback(() => r(!1), [r]);
  return /* @__PURE__ */ l("div", { className: e, children: a.cloneElement(o, {
    ref: n,
    onClick: i,
    ...s
  }) });
});
export {
  w as Modal,
  P as ModalClose,
  D as ModalContent,
  L as ModalDescription,
  E as ModalHeading
};
